module UU
  module OS
    module Artifact
      class ReferenceType

        # Link to an artifact in content.
        ARTIFACT_LINK = 'ARTIFACT_LINK'

        # Link to an attachment of an artifact in content.
        ATTACHMENT_LINK = 'ATTACHMENT_LINK'

        # Link to a property of an artifact in content.
        PROPERTY_LINK = 'PROPERTY_LINK'

        # The link to an activity of the artifact.
        ACTIVITY_LINK = 'ACTIVITY_LINK'

        # Citation of a block of content.
        CITATION = 'CITATION'

        # Reference to an artifact or an aggregated object by a property (more precisely property type REFERENCE, see {UU::OS::Property::PropertyType PropertyType} for more info).
        PROPERTY_REFERENCE = 'PROPERTY_REFERENCE'

      end

    end
  end
end
