require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS
    module Folder
      class FolderSetAttributes < UU::OS::REST::DTO

        #
        # @see Folder#set_attributes
        attr_accessor :code

        #
        # @see Folder#set_attributes
        attr_accessor :name

        #
        # @see Folder#set_attributes
        attr_accessor :description

        #
        # @see Folder#set_attributes
        attr_accessor :security_level

        #
        # @see Folder#set_attributes
        attr_accessor :icon_uri

        # @see Folder#set_attributes
        attr_accessor :component_content
        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def security_level
          attributes[:securityLevel]
        end

        def security_level=(val)
          attributes[:securityLevel] = val
        end

        def icon_uri
          attributes[:iconUri]
        end

        def icon_uri=(val)
          if val
            attributes[:iconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:iconUri] = nil
          end
        end

        def component_content
          attributes[:componentContent]
        end

        def component_content=(val)
          attributes[:componentContent] = val
        end

      end
    end

  end
end
