require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Meta Permission.
    module MetaPermission
      # DTO containing attributes of the authority.
      class MetaPermissionGetAuthorityListItem < UU::OS::REST::DTO

        # UESURI of the template object for which the authority has granted meta permissions.
        attr_accessor :uri

        # UESURI of the authority.
        attr_accessor :authority_uri

        # Name of the authority.
        attr_accessor :authority_name
        def uri
          attributes[:uri]
        end

        def uri=(val)
          if val
            attributes[:uri] = UU::OS::UESURI.new(val)
          else
            attributes[:uri] = nil
          end
        end

        def authority_uri
          attributes[:authorityUri]
        end

        def authority_uri=(val)
          if val
            attributes[:authorityUri] = UU::OS::UESURI.new(val)
          else
            attributes[:authorityUri] = nil
          end
        end

        def authority_name
          attributes[:authorityName]
        end

        def authority_name=(val)
          attributes[:authorityName] = val
        end

      end
    end

  end
end

