require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Role.
    module Role
      # @see Role#create
      class RoleCreate < UU::OS::REST::DTO

        # @see Role#create
        attr_accessor :meta_artifact_uri

        # @see Role#create
        attr_accessor :code

        # @see Role#create
        attr_accessor :name

        # @see Role#create
        attr_accessor :description

        # @see Role#create
        attr_accessor :competent_role_uri

        # @see Role#create
        attr_accessor :security_level

        # @see Role#create
        attr_accessor :searchable_in_territory

        # @deprecated This attribute has been deprecated and will not be supported in the future.
        attr_accessor :searchable_across_territories

        # @deprecated This attribute has been deprecated. The visual use case for displaying territories and organizational units, which this attribute was used for, is no longer supported.
        attr_accessor :territory_switch_visible

        # @see Role#create
        attr_accessor :icon_uri

        # @deprecated All From OU will not be used in the new authorization (v4).
        attr_accessor :grant_all_from_organizational_unit

        # @see Role#create
        attr_accessor :dry_run

        # @see Role#create
        attr_accessor :component_content

        def meta_artifact_uri
          attributes[:metaArtifactUri]
        end

        def meta_artifact_uri=(val)
          if val
            attributes[:metaArtifactUri] = UU::OS::UESURI.new(val)
          else
            attributes[:metaArtifactUri] = nil
          end
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def competent_role_uri
          attributes[:competentRoleUri]
        end

        def competent_role_uri=(val)
          if val
            attributes[:competentRoleUri] = UU::OS::UESURI.new(val)
          else
            attributes[:competentRoleUri] = nil
          end
        end

        def security_level
          attributes[:securityLevel]
        end

        def security_level=(val)
          attributes[:securityLevel] = val
        end

        def searchable_in_territory
          attributes[:searchableInTerritory]
        end

        def searchable_in_territory=(val)
          attributes[:searchableInTerritory] = val
        end

        # @deprecated This attribute has been deprecated and will not be supported in the future.
        def searchable_across_territories
          attributes[:searchableAcrossTerritories]
        end

        # @deprecated This attribute has been deprecated and will not be supported in the future.
        def searchable_across_territories=(val)
          attributes[:searchableAcrossTerritories] = val
        end

        # @deprecated This attribute has been deprecated. The visual use case for displaying territories and organizational units, which this attribute was used for, is no longer supported.
        def territory_switch_visible
          attributes[:territorySwitchVisible]
        end

        # @deprecated This attribute has been deprecated. The visual use case for displaying territories and organizational units, which this attribute was used for, is no longer supported.
        def territory_switch_visible=(val)
          attributes[:territorySwitchVisible] = val
        end

        def icon_uri
          attributes[:iconUri]
        end

        def icon_uri=(val)
          if val
            attributes[:iconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:iconUri] = nil
          end
        end

        # @deprecated All From OU will not be used in the new authorization (v4).
        def grant_all_from_organizational_unit
          attributes[:grantAllFromOrganizationalUnit]
        end

        # @deprecated All From OU will not be used in the new authorization (v4).
        def grant_all_from_organizational_unit=(val)
          attributes[:grantAllFromOrganizationalUnit] = val
        end

        def dry_run
          attributes[:dryRun]
        end

        def dry_run=(val)
          attributes[:dryRun] = val
        end

        def component_content
          attributes[:componentContent]
        end


        def component_content=(val)
          attributes[:componentContent] = val
        end

      end
    end

  end

end
