require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS

    module RoleInterface
      class RoleInterfaceGetMetaArtifactListItem < UU::OS::REST::DTO

        # Normalized UESURI of the meta artifact. Never nil.
        attr_accessor :uri

        # Name of the meta artifact. Never nil.
        attr_accessor :name

        # Code of the meta artifact. Never nil.
        attr_accessor :code

        # This attribute indicates whether the user can create artifacts from a given meta artifact.
        # The attribute will be supported for a limited time.
        # @deprecated
        attr_accessor :valid_relation

        # UESURI of the entity type of the meta artifact. Never nil.
        attr_accessor :entity_type_uri

        def uri
          attributes[:uri]
        end

        def uri=(val)
          if val
            attributes[:uri] = UU::OS::UESURI.new(val)
          else
            attributes[:uri] = nil
          end
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def valid_relation
          attributes[:validRelation]
        end

        def valid_relation=(val)
          attributes[:validRelation] = val
        end

        def entity_type_uri
          attributes[:entityTypeUri]
        end

        def entity_type_uri=(val)
          if val
            attributes[:entityTypeUri] = UU::OS::UESURI.new(val)
          else
            attributes[:entityTypeUri] = nil
          end
        end

      end
    end

  end
end
