require 'uu/os/rest/paging_criteria'

module UU
  module OS
    module Sheet
      class SheetGetSheetList < UU::OS::REST::PagingCriteria

        # The <b>UES query</b> string. It has to conform the ues query syntax (see documentation
        # for more info). Filtering and order of theresult list can be specified there. When
        # null is set, no filtering is applied and entries are ordered by name and code as the
        # second criteria.
        attr_accessor :query

        #@private
        # Nonfunctional, present only for backward compatibility.
        attr_accessor :code_filter

        #@private
        # Nonfunctional, present only for backward compatibility.
        attr_accessor :name_filter

        #@private
        # Nonfunctional, present only for backward compatibility.
        attr_accessor :only_main
        def query 
          attributes[:query]
        end

        def query=(val) 
          attributes[:query] = val
        end

        def code_filter 
          attributes[:codeFilter]
        end

        def code_filter=(val) 
          attributes[:codeFilter] = val
        end

        def name_filter 
          attributes[:nameFilter]
        end

        def name_filter=(val) 
          attributes[:nameFilter] = val
        end

        def only_main 
          attributes[:onlyMain]
        end

        def only_main=(val) 
          attributes[:onlyMain] = val
        end

      end
    end

  end
end
